# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

from tvtk.tvtk_classes.gpu_volume_ray_cast_mapper import GPUVolumeRayCastMapper


class OpenGLGPUVolumeRayCastMapper(GPUVolumeRayCastMapper):
    """
    OpenGLGPUVolumeRayCastMapper - no description provided.
    
    Superclass: GPUVolumeRayCastMapper
    
    
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkOpenGLGPUVolumeRayCastMapper, obj, update, **traits)
    
    def _get_color_texture(self):
        return wrap_vtk(self._vtk_obj.GetColorTexture())
    color_texture = traits.Property(_get_color_texture, help=\
        """
        Low level API to enable access to color texture in
        render_to_texture mode.
        """
    )

    def _get_depth_texture(self):
        return wrap_vtk(self._vtk_obj.GetDepthTexture())
    depth_texture = traits.Property(_get_depth_texture, help=\
        """
        Low level API to enable access to depth texture in
        render_to_texture mode.
        """
    )

    def _get_input(self):
        return wrap_vtk(self._vtk_obj.GetInput())
    input = traits.Property(_get_input, help=\
        """
        Set/Get the input data
        """
    )

    _updateable_traits_ = \
    (('mask_type', 'GetMaskType'), ('cropping_region_flags',
    'GetCroppingRegionFlags'), ('max_memory_fraction',
    'GetMaxMemoryFraction'), ('maximum_image_sample_distance',
    'GetMaximumImageSampleDistance'), ('reference_count',
    'GetReferenceCount'), ('render_to_image', 'GetRenderToImage'),
    ('report_progress', 'GetReportProgress'), ('final_color_window',
    'GetFinalColorWindow'), ('minimum_image_sample_distance',
    'GetMinimumImageSampleDistance'), ('blend_mode', 'GetBlendMode'),
    ('mask_blend_factor', 'GetMaskBlendFactor'),
    ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('auto_adjust_sample_distances', 'GetAutoAdjustSampleDistances'),
    ('progress_text', 'GetProgressText'), ('max_memory_in_bytes',
    'GetMaxMemoryInBytes'), ('final_color_level', 'GetFinalColorLevel'),
    ('image_sample_distance', 'GetImageSampleDistance'), ('abort_execute',
    'GetAbortExecute'), ('release_data_flag', 'GetReleaseDataFlag'),
    ('scalar_mode', 'GetScalarMode'), ('debug', 'GetDebug'), ('progress',
    'GetProgress'), ('cropping', 'GetCropping'), ('sample_distance',
    'GetSampleDistance'))
    
    _full_traitnames_list_ = \
    (['abort_execute', 'auto_adjust_sample_distances', 'cropping',
    'debug', 'global_warning_display', 'release_data_flag',
    'render_to_image', 'blend_mode', 'cropping_region_flags', 'mask_type',
    'scalar_mode', 'final_color_level', 'final_color_window',
    'image_sample_distance', 'mask_blend_factor', 'max_memory_fraction',
    'max_memory_in_bytes', 'maximum_image_sample_distance',
    'minimum_image_sample_distance', 'progress_text', 'report_progress',
    'sample_distance'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(OpenGLGPUVolumeRayCastMapper, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit OpenGLGPUVolumeRayCastMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['auto_adjust_sample_distances', 'cropping', 'render_to_image'],
            ['blend_mode', 'cropping_region_flags', 'mask_type', 'scalar_mode'],
            ['final_color_level', 'final_color_window', 'image_sample_distance',
            'mask_blend_factor', 'max_memory_fraction', 'max_memory_in_bytes',
            'maximum_image_sample_distance', 'minimum_image_sample_distance',
            'report_progress', 'sample_distance']),
            title='Edit OpenGLGPUVolumeRayCastMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit OpenGLGPUVolumeRayCastMapper properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

